#include <iostream>
using namespace std;
int jelpogodna(int x[100][100],int i1,int j1,int i2,int j2)
{
    int a=x[i1][j1];
    for(int i=i1;i<=i2;i++)
        for(int j=j1;j<=j2;j++)
            if(x[i][j]!=a)
                return 0;
    return 1;
}
int druga(int a,int x[100][100],int i1,int j1,int n)
{
    int i2,j2;
    for(int i=n;i>=i1;i--)
        for(int j=n;j>0;j--)
            if(x[i][j]==a)
            {
                i2=i;
                j2=j;
                if(jelpogodna(x,i1,j1,i2,j2))
                    return (i2-i1+1)*(j2-j1+1);
            }
    return 1;

}
int main()
{
    int u=0;
    int x[100][100],n,k;
    cin>>n>>k;
    int y[k];
    for(int i=1;i<=k;i++)
        y[i]=0;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
        {
            cin>>x[i][j];
            y[x[i][j]]++;
        }
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
            if(y[x[i][j]]==1||(druga(x[i][j],x,i,j,n)-y[x[i][j]]==0))
            {
                u++;
            }
            cout<<u;
    /*for(int i=0;i<k;i++)
        cout<<y[i]<<" ";*/

}